<template>
	<el-date-picker
		:type="props.type"
		:model-value="range"
		@update:model-value="handleUpdate"
		:clearable="props.clearable"
	/>
</template>

<script lang="ts" setup>
import { ElDatePicker } from "element-plus";
import { computed, PropType, ref, watch } from "vue-demi";
import { DateRange } from "../../../lib/utils";

const props = defineProps({
	modelValue: Object as PropType<Partial<DateRange>>,
	clearable: {
		type: Boolean,
		default: true,
	},
	type: {
		type: String as PropType<"daterange" | "week">,
		default: () => "daterange"
	}
});
const emit = defineEmits(['update:modelValue']);

const range = computed((): Date[] | undefined => {
	const val = props.modelValue;

	if (!val) {
		return undefined;
	}

	if (!val.begin || !val.end) {
		return undefined;
	}

	return [val.begin, val.end];
});

// function updateByRange(range: Partial<DateRange> | undefined): void {
// 	if (!range) {
// 		setIfNotSame(undefined);
// 		return;
// 	}

// 	const { begin, end } = range;

// 	if (!begin || !end) {
// 		setIfNotSame(undefined);
// 		return;
// 	}

// 	setIfNotSame([begin!, end!]);
// }

// function setIfNotSame(newVal: Date[] | undefined) {
// 	const oldVal = dateRange.value;

// 	const newLength = (newVal && newVal.length || 0);

// 	if (newLength === (oldVal?.length || 0)) {
// 		switch (newLength) {
// 			case 0:
// 			case 1:
// 				return; // same or not full

// 			default:
// 				if (compareDates(newVal![0], oldVal![0])
// 					&& compareDates(newVal![1], oldVal![1])) {
// 					return; // same
// 				}
// 		}
// 	}

// 	if (isValidDate(newVal && newVal[0]) && isValidDate(newVal && newVal[1])) {
// 		dateRange.value = newVal;
// 		return;
// 	}

// 	dateRange.value = undefined;
// }

function compareDates(d1: Date | undefined, d2: Date | undefined): boolean {
	if (d1 === d2) return true;

	const t1 = Number(d1?.getTime());
	const t2 = Number(d2?.getTime());

	return t1 === t2 || (isNaN(t1) === isNaN(t2));
}

function isValidDate(date: Date | undefined) {
	return !isNaN(Number(date?.getTime()));
}

function parseValue(val?: Date[]): DateRange | null {
	if (!val || val.length < 2) {
		return null;
	}

	return {
		begin: val[0],
		end: val[1]
	}
}

function handleUpdate(val?: Date[]) {
	emit('update:modelValue', parseValue(val));
}
</script>